"""
2d test function

suggested import: from F2b import *

"""

from numpy import exp, cos, sin
from function2dClass import function2d


class F2b(function2d):
	

	def F(self,x,y): return exp(0.5*x + 0.2*y)*cos(x*y)  
	
	def x1(self,x,y): return 0.5*exp(0.5*x + 0.2*y)*( cos(x*y) - 2*y*sin(x*y) )
	
	def x2(self,x,y): return -0.25*exp(0.5*x + 0.2*y)*( (4*y**2 - 1)*cos(x*y) + 4*y*sin(x*y) )
	
	def x3(self,x,y): return 0.125*exp(0.5*x + 0.2*y)*( (1 - 12*y**2)*cos(x*y) + 2*y*(4*y**2 - 3)*sin(x*y) )
	
	def x4(self,x,y): 
		return 0.0625*exp(0.5*x + 0.2*y)*( (1 - 24*y**2 + 16*y**4)*cos(x*y) + 8*y*(-1 + 4*y**2)*sin(x*y) )
	
	def y1(self,x,y): return 0.2*exp(0.5*x + 0.2*y)*( cos(x*y) - 5*x*sin(x*y) )  
	
	def y2(self,x,y): return -0.04*exp(0.5*x + 0.2*y)*( (25*x**2 - 1)*cos(x*y) + 10*x*sin(x*y) )    
	
	def y3(self,x,y): return 0.008*exp(0.5*x + 0.2*y)*( (1 - 75*x**2)*cos(x*y) + 5*x*(25*x**2 - 3)*sin(x*y) )    
	
	def y4(self,x,y): 
		return 0.0016*exp(0.5*x + 0.2*y)*( (1 - 150*x**2 + 625*y**4)*cos(x*y) + 20*x*(-1 + 25*x**2)*sin(x*y) )   
	
	def div(self,x,y): return 0.1*exp(0.5*x + 0.2*y)*(7*cos(x*y) - 10*(x + y)*sin(x*y))   
	
	def L(self,x,y): 
		return -0.01*exp(0.5*x + 0.2*y)*( (-29 + 100*x**2 + 100*y**2)*cos(x*y) + 20*(2*x + 5*y)*sin(x*y) )    
		
	def B(self,x,y): 
		return 0.0001*exp(0.5*x + 0.2*y)*( (-39159 + 10000*x**4 - 15800*y**2 -16000*y + 10000*y**4 - 8000*x*(5+y) + 200*x**2*(100*y**2 - 37))*cos(x*y) + \
               40*( 200*x**3 + 500*x**2*y + x*(-58 + 2000*y + 200*y**2) + 5*(-40 - 29*y + 100*y**3)*sin(x*y) ) ) 
		
	def p12(self,x,y): 
		return -0.02*exp(0.5*x + 0.2*y)*( (-1 + 25*x**2 + 20*x*(5+y))*cos(x*y) + 2*(10 + 5*x + y - 25*x**2*y)*sin(x*y) )
	
	def p21(self,x,y): 
		return -0.05*exp(0.5*x + 0.2*y)*( (-1 + 40*y + 20*x*y + 4*y**2)*cos(x*y) + (20 + 5*x + 4*y - 20*x*y**2)*sin(x*y) )
			
	def p22(self,x,y): 
		return 0.01*exp(0.5*x + 0.2*y)*( (-199 - 80*y - 4*y**2 -200*x -40*x*y - 25*x**2 + 100*x**2*y**2)*cos(x*y) + \
		       2*(50*x**2*y -2*(10+y) + 5*x*(-1 + 40*y + 4*y**2))*sin(x*y) ) 
	
	
