"""
2d test function

suggested import: from F2c import *

"""


from numpy import exp
from function2dClass import function2d


class F2c(function2d):
	
	def F(self,x,y): return  exp(x*y)
	
	def x1(self,x,y): return y*exp(x*y)
	
	def x2(self,x,y): return y**2*exp(x*y)
	
	def x3(self,x,y): return y**3*exp(x*y)
	
	def x4(self,x,y): return y**4*exp(x*y)
	
	def y1(self,x,y): return x*exp(x*y)
	
	def y2(self,x,y): return x**2*exp(x*y)   
	
	def y3(self,x,y): return x**3*exp(x*y)
	
	def y4(self,x,y): return x**4*exp(x*y)
	
	def div(self,x,y): return (x + y)*exp(x*y)  
	
	def L(self,x,y): return (x**2 + y**2)*exp(x*y)  
		
	def B(self,x,y): return (x**4 + 2*x**2*y**2 + 8*x*y + y**4 + 4)*exp(x*y)
		
	def p12(self,x,y): return x*(x*y + 2)*exp(x*y)
	
	def p21(self,x,y): return y*(x*y + 2)*exp(x*y)
			
	def p22(self,x,y): return (x**2*y**2 + 4*x*y + 2)*exp(x*y)
	
	
